#include <config.h>

#ifdef HAVE_HISTORY_H
#include <history.h>
#endif

#ifdef HAVE_READLINE_HISTORY_H
#include <readline/history.h>
#endif
typedef struct _modlist_ aModuleList;
typedef struct pidlist PidList;
int (*func)();

struct servlist
{
   char server[256];
};

typedef struct
{
  char *name;		
  Function *func; 
  char *doc;	
  int type; 
}
COMMAND;

typedef struct
{
   char *arg;
   int fd;
   int argc;
   char **argv;
   char *param;
   char *whole;
   struct servlist serv[100];
   int num;
   int cur;
}DCD;

struct _modlist_
{
  aModuleList *next, *prev;
  char *name;
  void *handle;
  Function *Finish;
  int numcommands;
};
struct pidlist
{
   pid_t pid;
};
int com_list (), com_play (), com_next (), com_prev (), com_stop (),
com_pause (), com_resume (), com_eject (), com_close (), com_status (),
com_clear (), com_reset (), com_quit (), com_getvol (), com_setvol (),
com_info (), com_ff (), com_rew (), com_delcache (), com_edit (),
com_submit (), com_help (), com_insmod (), com_rmmod (), com_type (),
com_acc (), com_sav (), com_rand (), com_tim (), com_lsmod (), com_loop (),
com_kill (), com_chan();

extern int
com_tim (DCD *dcd);
extern int
com_play (DCD *dcd);
extern int
com_insmod (DCD *dcd);
extern int
com_rand (DCD *dcd);
extern int
com_getvol (DCD *dcd);
extern int
com_setvol (DCD *dcd);
extern int
com_reset (DCD *dcd);
extern int
com_next (DCD *dcd);
extern int
com_prev (DCD *dcd);
extern int
com_stop (DCD *dcd);
extern int
com_pause (DCD *dcd);
extern int
com_resume (DCD *dcd);
extern int
com_eject (DCD *dcd);
extern int
com_close (DCD *dcd);
extern int
com_quit (DCD *dcd);
extern int
com_info (DCD *dcd);
extern int
com_rew (DCD *dcd);
extern int
com_ff (DCD *dcd);
extern int
com_list (DCD *dcd);
extern int
com_status (DCD *dcd);
extern int
com_help (DCD *dcd);
extern int
com_edit (DCD *dcd);
extern int
com_submit (DCD *dcd);
extern int com_rmmod (DCD *dcd);
extern int
com_delcache (DCD *dcd);
extern int com_mode(DCD *dcd);
extern int com_loop(DCD *dcd);
extern int com_loopf(DCD *dcd);
extern int process_config (char *buf, FILE * fp, int llock, DCD *dcd);
extern int writetocddb (int type, char hostname[50], char access[50]);
extern int readrcconfig (int llock, DCD dcd);
extern int addserver(char *val, DCD *dcd);
